require 'rspec'
require 'rspec/parser/version'
require 'rspec/parser/struct'

module RSpec::Parser
  # @param *args (same as rspec cli)
  # @return [RSpec::Core::World]
  def self.get_world(*args)
    opts = RSpec::Core::ConfigurationOptions.new(*args)
    runner = RSpec::Core::Runner.new(opts)
    runner.setup(STDERR, STDOUT)
    runner.world
  end

  # @return [Hash] nested tree hash
  def self.run(*args)
    result = get_world(*args)
    root_suite = RSpec::Parser::Struct::Suite.new('__ROOT__', nil, nil, nil, [], [], {})
    result.example_groups.each do |example_group_class|
      suite = RSpec::Parser::Struct::Suite.create(example_group_class)
      root_suite.add_child suite
    end

    root_suite
  end
end